/*****************************************************************************************
 Copyright (c) 2002-2004 The UbixOS Project
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are
 permitted provided that the following conditions are met:

 Redistributions of source code must retain the above copyright notice, this list of
 conditions, the following disclaimer and the list of authors.  Redistributions in binary
 form must reproduce the above copyright notice, this list of conditions, the following
 disclaimer and the list of authors in the documentation and/or other materials provided
 with the distribution. Neither the name of the UbixOS Project nor the names of its
 contributors may be used to endorse or promote products derived from this software
 without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id$

*****************************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/sys.h>
#include <sys/sched.h>
#include <sys/mpi.h>

int main(int argc,char **argv) {
  int i=0;
  mpiMessage_t myMsg;

  /* Create a mailbox for this task */
  if (mpiCreateMbox("init") != 0x0) {
    printf("Error: Error Creating Mail Box\n");
    exit(-1);
    }

  /* Test to see if we were started by the system if not exit */
  if (getpid() != 1) {
    printf("Error: This program must be started by kernel.\n");
    //exit(1);
    }

  /* Make sure we have superuser permissions if not exit */
  if ((getuid() != 0) && (getgid() != 0)) {
    printf("Error: This program must be run by root.\n");
    exit(1);
    }

  /* Start the SDE(SCreen Drawing Engine) */
  startSDE();

  printf("Initializing System.\n");
 
  i = fork();
  if (0 == i) {
    printf("Starting Ubix Registry (ubistry)\n");
    exec("ubistry@sys",0x0,0x0);
    printf("Error: Error Starting ubistry\n");
    exit(-1);
    }
  while (pidStatus(i) > 0x0) {
    sched_yield();
    }

  startup:
  i = fork();
  if (0 == i) {
    printf("Starting Login Daemon.\n");
    exec("login@sys",0x0,0x0);
    printf("Error Starting System\n");
    exit(-1);
    }
  else {
    while (pidStatus(i) > 0x0) {
      fetchAgain:
      if (mpiFetchMessage("init",&myMsg) == 0x0) {
        switch (myMsg.type) {
          case 10:
            printf("Exec: (%s)\n",myMsg.data);
            break;
          default:
            printf("MailBox: init Received Message %i:%s\n",myMsg.type,myMsg.data);
            break;
          }
        goto fetchAgain;
        }
      sched_yield();
      }
    goto startup;
    }
  return(0);
  }

/***
 $Log$
 Revision 1.9  2004/05/26 12:19:19  reddawg
 init: init now starts the ubix registry system

 Revision 1.8  2004/05/25 22:44:59  reddawg
 Test code

 Revision 1.7  2004/05/25 22:32:58  reddawg
 We turned back on GUI

 Revision 1.6  2004/05/25 18:38:00  reddawg
 The system INIT task now responds to messages it is the root process for the OS

 Revision 1.5  2004/05/25 15:43:44  reddawg
 Tests for MPI

 Revision 1.4  2004/05/23 23:40:37  reddawg
 Cleanup

 Revision 1.3  2004/05/21 21:15:56  reddawg
 Cleaned up initialized program

 Revision 1.2  2004/05/21 15:43:58  reddawg
 Fixed the the bootup ordering in userland initialization

 END
 ***/
